Index: /WAeUP_SRP/branches/joachim-event-branch/Students.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/Students.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/Students.py	(revision 1596)
@@ -1398,363 +1246,6 @@
     ###)
 
-    security.declareProtected(ModifyPortalContent,"OLDloadPumeResultsFromCSV")###(
-    def OLDloadPumeResultsFromCSV(self):
-        """load Fulltime Studentdata from CSV values"""
-        import transaction
-        import random
-        wftool = self.portal_workflow
-        students_folder = self.portal_catalog({'meta_type': 'StudentsFolder'})[-1].getObject()
-        csv_d = {'jamb_reg_no': "JAMBRegno",
-                 'jamb_lastname': "Name",
-                 'pume_options': "Options",
-                 'session': "Session",
-                 'days': "Days",
-                 'response': "Responce",
-                 'wrong': "Wrong",
-                 'pume_eng_score': "EngScore",
-                 'pume_gen_score': "GenScore",
-                 'pume_tot_score': "Score",
-                 'batch': "Batch",
-                 'serial': "SerialNo",
-                 'jamb_score': "JambScore",
-                 'omitted':"Omitted",
-                 'search_key': "SearchKey",
-                 'jamb_sex': "Sex",
-                 'fac1': "Fac1",
-                 'fac2': "Fac2",
-                 'jamb_first_cos': "CourseofStudy",
-                 'stud_status':"StudStatus",
-                 'registered': "Registered",
-                 'jamb_state': "State",
-                 'eng_fail': "EngFail",
-                 'gen_fail': "GenFail",
-                 'un_ans_eng': "UnAnsEng",
-                 'un_ans_eng': "UnAnsGen",
-                 'total_ans': "TotalUnAns",
-                 'dept': "Dept",
-                 'jamb_second_cos': "Course2",
-                 'jamb_third_cos': "course3",
-                 }
-        csv_fields = [f[1] for f in csv_d.items()]
-        tr_count = 0
-        name = 'pume_results'
-        no_import = []
-        s = ','.join(['"%s"' % fn for fn in csv_fields])
-        no_import.append('%s\n' % s)
-        logger = logging.getLogger('Import.%s' % name)
-        logger.info('Start loading from %s.csv' % name)
-        try:
-            result = csv.DictReader(open("%s/import/%s.csv" % (i_home,name),"rb"))
-        except:
-            logger.error('Error reading %s.csv' % name)
-            return
-        for jamb in result:
-            format = ','.join(['"%%(%s)s"' % fn for fn in csv_fields])
-            processing = "processing %s" % format
-            logger.info(processing % jamb)
-            jamb_reg_no = jamb.get(csv_d['jamb_reg_no'])
-            #import pdb;pdb.set_trace()
-            res = self.portal_catalog({'portal_type': "StudentApplication",
-                                     'jamb_reg_no': jamb_reg_no })
-            if res:
-                em = 'Student with REG-NO %s already exists\n' % jamb_reg_no
-                logger.info(em)
-                no_import.append(em)
-                no_import.append(format % jamb)
-                continue
-            cert_id = jamb.get(csv_d['jamb_first_cos']).upper()
-            res = self.portal_catalog({'portal_type': "Certificate",
-                                     'id': cert_id })
-            if len(res) < 1:
-                em = 'No Certificate with ID %s \n' % cert_id
-                logger.info(em)
-                no_import.append(em)
-                no_import.append(format % jamb)
-                continue
-            cert = res[0].getObject()
-            cert_path = res[0].getPath()
-            cert_doc = cert.getContent()
-            jamb_name = jamb.get(csv_d['jamb_lastname'])
-            jamb_name.replace('>','')
-            names = jamb_name.split()
-            letter = names[-1][0].upper()
-            sid = self.generateStudentId(letter)
-            not_created = True
-            while not_created:
-                try:
-                    students_folder.invokeFactory('Student', sid)
-                    not_created = False
-                except BadRequest:
-                    sid = self.generateStudentId(letter)
-            logger.info('%(tr_count)s: Creating Student with ID %(sid)s REG-NO %(jamb_reg_no)s ' % vars())
-            student = getattr(self,sid)
-            student.manage_setLocalRoles(sid, ['Owner',])
-            student.invokeFactory('StudentClearance','clearance')
-            #wftool.doActionFor(student.clearance,'open')
-            dp = {'Title': 'Clearance/Eligibility Record'}
-            student.clearance.manage_setLocalRoles(sid, ['Owner',])
-            student.invokeFactory('StudentPume','pume')
-            dp = {'Title': 'Pume Data'}
-            student.invokeFactory('StudentApplication','application')
-            da = {'Title': 'Application Data'}
-            da["jamb_lastname"] = jamb_name
-            da_fields = ('jamb_reg_no',
-                         'jamb_sex',
-                         'jamb_state',
-                         'jamb_score',
-                         'jamb_first_cos',
-                         'jamb_sex',
-                         'jamb_state',
-                         'jamb_first_cos',
-                         'jamb_second_cos',
-                         )
-            for f in da_fields:
-                da[f] = jamb.get(csv_d[f])
-            app = student.application
-            app.getContent().edit(mapping=da)
-            app.manage_setLocalRoles(sid, ['Owner',])
-            #wftool.doActionFor(app,'close')
-            dp_fields = (
-                         'pume_eng_score',
-                         'pume_gen_score',
-                         'pume_tot_score',
-                         )
-            for f in dp_fields:
-                dp[f] = float(jamb.get(csv_d[f]))
-            pume = student.pume
-            pume.getContent().edit(mapping=dp)
-            #wftool.doActionFor(pume,'close')
-            pume.manage_setLocalRoles(sid, ['Owner',])
-            #
-            # Study Course
-            #
-            student.invokeFactory('StudentStudyCourse','study_course')
-            study_course = student.study_course
-            dsc = {}
-            from_certificate = ['title',
-                               'max_elect',
-                               'max_pass',
-                               'n_core',
-                               'nr_years',
-                               'probation_credits',
-                               'promotion_credits',
-                               'start_level',
-                              ]
-            for f in from_certificate:
-                dsc[f] = getattr(cert_doc,f)
-            cpl = cert_path.split('/')
-            dsc['faculty'] = cpl[-4]
-            dsc['department'] = cpl[-3]
-            dsc['study_course'] = cert_id
-            dsc['entry_session'] = jamb.get(csv_d['session'])
-            study_course.getContent().edit(mapping=dsc)
-            student.getContent().createSubObjects()
-            if dp['pume_tot_score']>49:
-                wftool.doActionFor(student,'pume_pass')
-                wftool.doActionFor(student,'admit')
-            else:
-                wftool.doActionFor(student,'pume_fail')
-                wftool.doActionFor(student,'reject_admission')
-            if len(no_import) > 1:
-                open("%s/import/%s_not_imported.csv" % (i_home,name),"w").write(
-                     '\n'.join(no_import))
-        return self.REQUEST.RESPONSE.redirect("%s" % self.REQUEST.get('URL1'))
-    ###)
-
-    security.declareProtected(ModifyPortalContent,"loadFullTimeStudentsResultsFromCSV") ###(
-    def loadFullTimeStudentsResultsFromCSV(self):
-        """load Fulltime Studentdata from CSV values"""
-        #return
-        level_wf_actions = {}
-        level_wf_actions["SUCCESSFUL STUDENT"] = "pass_A"
-        level_wf_actions["STUDENT WITH CARRYOVER COURSES"] = "pass_B"
-        level_wf_actions["STUDENT FOR PROBATION"] = "probate_C"
-        level_wf_actions["STUDENT ON PROBATION/TRANSFER"] = "reject_D"
-        import transaction
-        wftool = self.portal_workflow
-        tr_count = 0
-        name = 'short_full_time_results_2004_2005'
-        no_import = False
-        if not no_import:
-            no_import = open("%s/import/%s_not_imported.csv" % (i_home,name),"w")
-            no_import.write('"Matnumber","CosCode","Ansbook","CosStuatus","Session","Mat_Cos","Score","CarryLevel","Grade","Weight","Semster","Verdict","Level","id","GPA"\n')
-        logger = logging.getLogger('import.%s' % name)
-        logger.info('Start loading from %s.csv' % name)
-        students_folder = self.portal_catalog({'meta_type': 'StudentsFolder'})[-1].getObject()
-        try:
-            results = csv.DictReader(open("%s/import/%s.csv" % (i_home,name),"rb"))
-        except:
-            logger.error('Error reading %s.csv' % name)
-            return
-        l = self.portal_catalog({'meta_type': "Course"})
-        courses = {}
-        for c in l:
-            courses[c.id] = c.getObject()
-        level_changed = False
-        student_changed = False
-        sid = ''
-        #import pdb;pdb.set_trace()
-        for result in results:
-            temp_sid = result.get('Matnumber')
-            if temp_sid != sid:
-                student_changed = True
-                res = self.portal_catalog({'meta_type': "StudentClearance",
-                                         'SearchableText': temp_sid })
-                if not res:
-                    em = 'Student with ID %(Matnumber)s not found\n' % result
-                    logger.info(em)
-                    no_import.write(em)
-                    no_import.write('"%(Matnumber)s","%(CosCode)s","%(Ansbook)s","%(CosStuatus)s","%(Session)s","%(Mat_Cos)s","%(Score)s","%(CarryLevel)s","%(Grade)s","%(Weight)s","%(Semster)s","%(Verdict)s","%(Level)s","%(id)s","%(GPA)s"\n' % result)
-                    continue
-                elif len(res) > 1:
-                    em = 'More than one Student with ID %(Matnumber)s found\n' % result
-                    logger.info(em)
-                    no_import.write(em)
-                    no_import.write('"%(Matnumber)s","%(CosCode)s","%(Ansbook)s","%(CosStuatus)s","%(Session)s","%(Mat_Cos)s","%(Score)s","%(CarryLevel)s","%(Grade)s","%(Weight)s","%(Semster)s","%(Verdict)s","%(Level)s","%(id)s","%(GPA)s"\n' % result)
-                    continue
-                sid = temp_sid
-                sf = res[0].getObject().aq_parent
-                sc = getattr(sf,'study_course')
-                level = ''
-            else:
-                student_changed = False
-            course = result.get('CosCode')
-            if course not in courses.keys():
-                em = 'Course with ID %(CosCode)s not found\n' % result
-                logger.info(em)
-                no_import.write(em)
-                no_import.write('"%(Matnumber)s","%(CosCode)s","%(Ansbook)s","%(CosStuatus)s","%(Session)s","%(Mat_Cos)s","%(Score)s","%(CarryLevel)s","%(Grade)s","%(Weight)s","%(Semster)s","%(Verdict)s","%(Level)s","%(id)s","%(GPA)s"\n' % result)
-                continue
-            course_doc = courses[course].getContent()
-            temp_level = result.get('Level')
-            student_id = sf.getId()
-            result['StudentId'] = student_id
-            if temp_level != level:
-                try:
-                    int(temp_level)
-                except:
-                    em = 'Result with ID %(Matnumber)s Course %(CosCode)s Level is empty\n' % result
-                    logger.info(em)
-                    no_import.write(em)
-                    no_import.write('"%(Matnumber)s","%(CosCode)s","%(Ansbook)s","%(CosStuatus)s","%(Session)s","%(Mat_Cos)s","%(Score)s","%(CarryLevel)s","%(Grade)s","%(Weight)s","%(Semster)s","%(Verdict)s","%(Level)s","%(id)s","%(GPA)s"\n' % result)
-                    continue
-                level_changed = True
-                if 'dlev' in vars().keys():
-                    wftool.doActionFor(l,level_wf_actions[dlev['verdict']])
-                level = temp_level
-                l = getattr(sc,level,None)
-                if l is None:
-                    logger.info('Creating Level %(Level)s for %(StudentId)s %(Matnumber)s' % result)
-                    sc.invokeFactory('StudentStudyLevel', level)
-                    l = getattr(sc, level)
-                    l.manage_setLocalRoles(student_id, ['Owner',])
-            else:
-                level_changed = False
-            cr = getattr(l,course,None)
-            if cr is None:
-                logger.info('Creating Course %(CosCode)s for %(StudentId)s %(Matnumber)s in Level %(Level)s' % result)
-                l.invokeFactory('StudentCourseResult',course)
-            cr = getattr(l,course)
-            dcr = {}
-            from_course = ['title',
-                           'credits',
-                           'passmark',
-                           ]
-            for f in from_course:
-                dcr[f] = getattr(course_doc,f)
-            dlev = {}
-            dcr['ansbook'] = result.get('Ansbook')
-            dcr['semester'] = getInt(result.get('Semster'))
-            dcr['status'] = result.get('CosStuatus')
-            dcr['score'] = getInt(result.get('Score'))
-            dlev['session'] = result.get('Session')
-            dcr['carry_level'] = result.get('CarryLevel')
-            dcr['grade'] = result.get('Grade')
-            dcr['weight'] = result.get('Weight')
-            dlev['verdict'] = result.get('Verdict')
-            dcr['import_id'] = result.get('id')
-            gpa = result.get('GPA').replace(',','.')
-            dlev['imported_gpa'] = getFloat(gpa)
-            cr.getContent().edit(mapping = dcr)
-            cr.manage_setLocalRoles(student_id, ['Owner',])
-            l.getContent().edit(mapping = dlev)
-            if tr_count > MAX_TRANS:
-                transaction.commit()
-                tr_count = 0
-            tr_count += 1
-            wftool.doActionFor(cr,'close')
-        wftool.doActionFor(l,level_wf_actions[dlev['verdict']])
-        return self.REQUEST.RESPONSE.redirect("%s" % self.REQUEST.get('URL1'))
-
-###)
-
-    security.declareProtected(ModifyPortalContent,"loadJAMBFromCSV")###(
-    def loadJAMBFromCSV(self):
-        """load JAMB data from CSV values"""
-        #return
-        students_folder = self.portal_catalog({'meta_type': 'StudentsFolder'})[-1].getObject()
-        import transaction
-        tr_count = 0
-        name = 'SampleJAMBDataII'
-        wftool = self.portal_workflow
-        no_import = False
-        if not no_import:
-            no_import = open("%s/import/%s_not_imported.csv" % (i_home,name),"w")
-            no_import.write('REG-NO,NAME,SEX,STATE,LGA,ENG-SCORE,SUBJ1,SUBJ1-SCORE,SUBJ2,SUBJ2-SCORE,SUBJ3,SUBJ3-SCORE,AGGREGATE,UNIV1,FACULTY1,COURSE1,UNIV2,FACULTY2,COURSE2')
-        logger = logging.getLogger('Import.%s' % name)
-        logger.info('Start loading from %s.csv' % name)
-        try:
-            result = csv.DictReader(open("%s/import/%s.csv" % (i_home,name),"rb"))
-        except:
-            logger.error('Error reading %s.csv' % name)
-            return
-        for jamb in result:
-            logger.info('processing %(REG-NO)s,%(NAME)s,%(SEX)s,%(STATE)s,%(LGA)s,%(ENG-SCORE)s,%(SUBJ1)s,%(SUBJ1-SCORE)s,%(SUBJ2)s,%(SUBJ2-SCORE)s,%(SUBJ3)s,%(SUBJ3-SCORE)s,%(AGGREGATE)s,%(UNIV1)s,%(FACULTY1)s,%(COURSE1)s,%(UNIV2)s,%(FACULTY2)s,%(COURSE2)s\n' % jamb)
-            jamb_reg_no = jamb.get('REG-NO')
-            res = self.portal_catalog({'meta_type': "StudentApplication",
-                                     'jamb_reg_no': jamb_reg_no })
-            if res:
-                em = 'Student with REG-NO %(REG-NO)s already exists\n' % jamb
-                logger.info(em)
-                no_import.write(em)
-                no_import.write('%(REG-NO)s,%(NAME)s,%(SEX)s,%(STATE)s,%(LGA)s,%(ENG-SCORE)s,%(SUBJ1)s,%(SUBJ1-SCORE)s,%(SUBJ2)s,%(SUBJ2-SCORE)s,%(SUBJ3)s,%(SUBJ3-SCORE)s,%(AGGREGATE)s,%(UNIV1)s,%(FACULTY1)s,%(COURSE1)s,%(UNIV2)s,%(FACULTY2)s,%(COURSE2)s\n' % jamb)
-                continue
-            jamb_name = jamb.get("NAME")
-            jamb_name.replace('>','')
-            names = jamb_name.split()
-            letter = names[-1][0].upper()
-            sid = self.generateStudentId(letter)
-            not_created = True
-            while not_created:
-                try:
-                    students_folder.invokeFactory('Student', sid)
-                    not_created = False
-                except BadRequest:
-                    sid = self.generateStudentId(letter)
-            logger.info('%(tr_count)s: Creating Student with ID %(sid)s REG-NO %(jamb_reg_no)s ' % vars())
-            student = getattr(self,sid)
-            student.manage_setLocalRoles(sid, ['Owner',])
-            student.invokeFactory('StudentApplication','application')
-            da = {'Title': 'Application Data'}
-            da["jamb_reg_no"] = jamb.get("REG-NO")
-            da["jamb_lastname"] = jamb_name
-            da["jamb_sex"] = jamb.get("SEX")
-            da["jamb_state"] = jamb.get("STATE")
-            da["jamb_lga"] = jamb.get("LGA")
-            da["jamb_score"] = jamb.get("AGGREGATE")
-            da["jamb_first_cos"] = jamb.get("COURSE1")
-            da["jamb_second_cos"] = jamb.get("COURSE2")
-            da["jamb_first_uni"] = jamb.get("UNIV1")
-            da["jamb_second_uni"] = jamb.get("UNIV2")
-            app = student.application
-            app_doc = app.getContent()
-            app_doc.edit(mapping=da)
-            #wftool.doActionFor(app,'open',dest_container=app)
-            app.manage_setLocalRoles(sid, ['Owner',])
-            student.getContent().createSubObjects()
-        return self.REQUEST.RESPONSE.redirect("%s" % self.REQUEST.get('URL1'))
-    ###)
-
- 
+
+
     security.declareProtected(View,"fixOwnership")
     def fixOwnership(self):
Index: /WAeUP_SRP/branches/joachim-event-branch/WAeUPTables.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/WAeUPTables.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/WAeUPTables.py	(revision 1596)
@@ -142,6 +142,6 @@
         rec = records[0]
         self.modifyRecord(bed=rec.bed,student=student_id)
-        s_logger = logging.getLogger('Accommodation.SearchAndReserveBed')
-        s_logger.info("%s reserved bed %s" % (student_id,rec.bed))
+        s_logger = logging.getLogger('WAeUPTables.AccommodationTable.searchAndReserveBed')
+        s_logger.info('%s reserved bed %s' % (student_id,rec.bed))
         return 1,rec.bed
 
@@ -224,4 +224,6 @@
         WAeUPTable.__init__(self, 'students_catalog')
 
+        
+        
     security.declarePrivate('notify_event_listener')
     def notify_event_listener(self,event_type,object,infos):
@@ -246,4 +248,5 @@
                 return
             student_id = infos['rpath'].split('/')[2]
+            self.fixName(student_id)
             student_entry = students_catalog(id = student_id)[0]
             if student_entry.jamb_reg_no == jamb_reg_no:
@@ -251,5 +254,10 @@
             students_catalog.modifyRecord(id = student_id,
                                           jamb_reg_no = jamb_reg_no)
-        
+        elif mt == 'StudentPersonal':
+            if event_type not in ('sys_modify_object'):
+                return
+            print "%(pt)s\n %(event_type)s \n %(infos)s\n" % vars()
+            student_id = infos['rpath'].split('/')[2]
+            self.fixName(student_id)
             
 
Index: /WAeUP_SRP/branches/joachim-event-branch/WAeUPTool.py
===================================================================
--- /WAeUP_SRP/branches/joachim-event-branch/WAeUPTool.py	(revision 1595)
+++ /WAeUP_SRP/branches/joachim-event-branch/WAeUPTool.py	(revision 1596)
@@ -109,5 +109,5 @@
         student_entry = getattr(self.portal_directories.students,student_id,None)
         if student_entry is None:
-            return 
+            return
         setattr(student_entry,'password',password)
     ###)
@@ -288,5 +288,5 @@
         "create Datastructure for a returning Student"
         #import pdb;pdb.set_trace()
-        logger = logging.getLogger('Student.CreateData')
+        logger = logging.getLogger('WAeUPTool.makeStudentData')
         students_folder = self.portal_url.getPortalObject().campus.students
         res = self.students_catalog(id=student_id)
@@ -296,5 +296,5 @@
         if res:
             student = res[0]
-        logger.info('"%s", "creating Datastructure"' % student_id)
+        logger.info('%s creates data structure' % student_id)
         s_results = self.results_import(matric_no = st.matric_no)
         lnr = self.getLevelFromResultsCosCode(s_results)
@@ -404,5 +404,5 @@
         "create the StudyLevel for a returning Student"
         #import pdb;pdb.set_trace()
-        logger = logging.getLogger('Student.CreateLevel')
+        logger = logging.getLogger('WAeUPTool.makeStudentLevel')
         students_folder = self.portal_url.getPortalObject().campus.students
         res = self.students_catalog(id=student_id)
@@ -415,5 +415,5 @@
         if res:
             results = res
-        logger.info('"%s", "creating Level", "%s"' % (student_id,level))
+        logger.info('%s creating Level %s' % (student_id,level))
         #
         # Level
@@ -478,4 +478,57 @@
     ###)
 
+    security.declareProtected(ModifyPortalContent,'getLogfileLines') ###(
+    def getLogfileLines(self,filename="event.log",numlines=20):
+        """Get last NUMLINES lines of logfile FILENAME.
+
+        Return last lines' of a file in the instances logfile directory as
+        a list. The number of returned lines equals `numlines' or less. If
+        less than `numlines' lines are available, the whole file ist
+        returned. If the file can not be opened or some other error
+        occurs, empty list is returend.
+        """
+        result = []
+        lines_hit = 0
+
+        # We only handle files in instances' log directory...
+        logpath = os.path.join(i_home, "log")
+        filename = str(os.path.abspath( os.path.join( logpath, filename )))
+        if not filename.startswith( logpath ):
+            # Attempt to access file outside log-dir...
+            return []
+
+        try:
+            fd = file( filename, "rb" )
+        except IOError:
+            return []
+        if not fd:
+            return []
+
+        if os.linesep == None:
+            linesep = '\n'
+        else:
+            linesep = os.linesep
+
+        # Try to find 'numlines' times a lineseparator, searching from end
+        # and moving to the beginning of file...
+        fd.seek( 0, 2) # Move to end of file...
+        while lines_hit < numlines:
+            if fd.read(1) == linesep[-1]: # This moves filedescriptor
+                                          # one step forward...
+                lines_hit += 1
+            try:
+                fd.seek( -2, 1) # Go two bytes back from current pos...
+            except IOError:
+                # We cannot go back two bytes. Maybe the file is too small...
+                break
+        fd.seek(2,1)
+
+        # Read all lines from current position...
+        result = fd.readlines()
+        # Remove line endings...
+        result = [x.strip() for x in result]
+        fd.close()
+        return result
+    ###)
 
 InitializeClass(WAeUPTool)
